]> git.xonotic.org Git - xonotic/xonotic.git/blobdiff - misc/tools/xonotic-map-compiler-autobuild
autobuild scripts: specify timeouts for the q3map2 stages
[xonotic/xonotic.git] / misc / tools / xonotic-map-compiler-autobuild
index f33fb9dec344d39c6727db78bd9371d69be0bc02..9534301ee0683b3fda07191d9cfcccfb6b7b20c4 100755 (executable)
@@ -4,6 +4,7 @@ set -e
 
 bspdir="$PWD/data"
 url=http://141.2.16.23/~xonotic/bsp-autobuilds/
+override="-bsp_timeout 900 -vis_timeout 3600 -light_timeout 14400 -minimap_timeout 900 -scale_timeout 900"
 
 bspoutdir="$HOME/public_html/bsp-autobuilds/"
 
@@ -23,12 +24,28 @@ allmaps()
        done
 }
 
+pre2spam()
+{
+       map=$1
+       url=$2
+       branch=$3
+       hash=$4
+
+       branch=${branch##refs/heads/}
+       branch=${branch##refs/remotes/}
+       branch=${branch##origin/}
+       hash=`echo "$hash" | cut -c 1-7`
+
+       echo "[$branch $hash] starting map compile of $map"
+}
+
 log2spam()
 {
        map=$1
        url=$2
        branch=$3
        hash=$4
+       status=$5
 
        branch=${branch##refs/heads/}
        branch=${branch##refs/remotes/}
@@ -40,6 +57,9 @@ log2spam()
        s_leaked=
        s_error=
 
+       if [ "$status" -ne 0 ]; then
+               s_error="exited with status $status"
+       fi
        while IFS= read -r L; do
                case "$L" in
                        *\ seconds\ elapsed)
@@ -68,9 +88,9 @@ log2spam()
        s_failshaders=`echo "$s_failshaders" | sed "s, textures/, ,g"`
        s_failshaders=${s_failshaders# }
        if [ -n "$s_error" ]; then
-               echo -n "[$branch] \ 34failed"
+               echo -n "[$branch $hash\ 34failed"
        else
-               echo -n "[$branch] finished"
+               echo -n "[$branch $hash] finished"
        fi
        echo -n " map compile of $map ($url): $s_time sec"
        if [ -n "$s_samplesize" ]; then
@@ -103,14 +123,21 @@ buildthemap()
        if [ -f "$bspdir/$M-$blobhash.pk3" ]; then
                continue
        fi
+       if [ -n "$IRCSPAM" ]; then
+               pre2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
+       fi
        (
                cd maps
-               ../../../misc/tools/xonotic-map-compiler "$M" `head -n 1 "$M.map.options"` 2>&1 | tee "$M.log"
+               ../../../misc/tools/xonotic-map-compiler "$M" `grep ^- "$M.map.options" | cut -d '#' -f 1` $override > "$M.log"
        )
-       zip -9r "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
+       status=$?
+       if [ -n "$IRCSPAM" ]; then
+               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" "$status" > "maps/$M.irc"
+       fi
+       zip -9r "$bspdir/$M-$blobhash.pk3" "maps/$M.bsp" "maps/$M.log" "maps/$M.irc" "maps/$M/" "maps/$M.lin" "gfx/${M}_mini.tga"
        ln -snf "../$M-$blobhash.pk3" "$bspdir/latest/$M.pk3" # from ALL branches, so beware!
        if [ -n "$IRCSPAM" ]; then
-               cat "maps/$M.log" | log2spam "$M" "$url$M-$blobhash.pk3" "$REFNAME" "$HASH" | $IRCSPAM
+               $IRCSPAM < "maps/$M.irc"
        fi
 }
 
@@ -127,12 +154,12 @@ getthemap()
        if ! wget -O "$bspdir/$M-$blobhash.pk3" "$url$M-$blobhash.pk3"; then
                rm -f "$bspdir/$M-$blobhash.pk3"
                echo "WARNING: could not download $url$M-$blobhash.pk3, maybe not ready yet"
-               return 1
+               return 0
        fi
        if ! unzip -l "$bspdir/$M-$blobhash.pk3"; then
                rm -f "$bspdir/$M-$blobhash.pk3"
                echo "WARNING: could not download $url$M-$blobhash.pk3, invalid zip file"
-               return 1
+               return 0
        fi
 }
 
@@ -164,6 +191,6 @@ case "$1" in
                wget -r -l1 -A "*.pk3" -N --no-parent --no-directories "$url""latest"
                ;;
        log2spam-test)
-               log2spam "mapname" "http://mapurl" "branch" "commit"
+               log2spam "mapname" "http://mapurl" "branch" "commit" "0"
                ;;
 esac